

#include <avr/interrupt.h>
#include <avr/io.h>

#include <util/delay.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include <stdlib.h>
#include "lcd.h"

#define UP    0
#define DOWN  1
#define LEFT  2
#define RIGHT 3
#define NONE  5

// directia de miscare (initial spre dreapta)
uint8_t snake_direction;

#define WORLD_WIDTH 50
#define WORLD_HEIGHT 20
#define FOREVER 	1
#define INIT_ROW 	15
#define INIT_COL 	20

//Declaram structuri pentru obstacole,hrana, chenar si sarpe

struct obstacol {
	int x;
	int y;
};
struct hrana {
 	int x;
 	int y;
 };
 struct chenar {
 	int x;
 	int y;
 	char simbol;
 };
 struct sarpe {
 	int x;
 	int y;
 	int lungime;
 	char simbol;
 };
 

/* Setare directii porturi folosite */
/*
void init_buttons(void) {

    DDRB = 0xff;
    PORTB = 0x00;

    // UP
    DDRB &= ~(1 << PB0);
    PORTB |= (1 << PB0);
    
    // LEFT
    DDRB &= ~(1 << PB1);
    PORTB |= (1 << PB1);
    
    // RIGHT
    DDRB &= ~(1 << PB2);
    PORTB |= (1 << PB2);
    
    // DOWN
    DDRB &= ~(1 << PB3);
    PORTB |= (1 << PB3);
    
  
}

*/

/* Verificare butoane apasate */
void check_input(void) {

    // UP
    if (!(PINB & (1 << PB0))) {
        snake_direction = UP;
    }
    
    // LEFT
    if (!(PINB & (1 << PB1))) {
        snake_direction = LEFT;
    }
    
    // RIGHT
    if (!(PINB & (1 << PB2))) {
        snake_direction = RIGHT;
    }
    
    // DOWN
    if (!(PINB & (1 << PB3))) {
        snake_direction = DOWN;
    }
}

/* initializeaza intrarile si iesirile */
void IO_init()
{
    // butoanele sunt puse ca intrare, cu rezistenta de pull-up
    DDRB &= ~((1 << PB0) | (1 << PB1)| (1 << PB2) | (1 << PB3));
    PORTB |= ((1 << PB0) | (1 << PB1)| (1 << PB2) | (1 << PB3));
    
    // intreruperile sunt activate pentru PCINT8 (PB0) si PCINT9 (PB1)
    PCICR  = (1 << PCIE1);
    PCMSK1 = (1 << PCINT8) | (1 << PCINT9) | (1 << PCINT10) | (1 << PCINT11);
}



int main(void)
{
    // initializari si testare interfeta afisare/debug
    IO_init();
	lcd_init();
	snake_direction = NONE;
	// Print on first line
	int selectedMode = 0;
	lcd_str("Selectati modul! UP pt.obstacole, DOWN pt. joc normal");
	
	int nrows,scor=0, ncols,i,j,x,y,dif,lungime,mod, a=0,var=100,nr=0,oarecare,k;
	char c,m,d,nume[50];
	int ch;
	struct chenar border[100];
	struct sarpe snake[100];
	struct hrana food;
	struct obstacol obs[10];
	
	/*Se initializeaza lungimea sarpelui*/
	lungime=5;
	
	
	
	nrows =  LCD_X_RES;
	ncols =  LCD_Y_RES;
	
	while(selectedMode == 0)
	{
        check_input();
        
        // start game
        if (snake_direction == UP)
		{
			m = 'o';
			lcd_clear();
			lcd_str("Joc cu obstacole");
			selectedMode = 1;
		}
		
		if (snake_direction == DOWN)
		{
			m = 'n';
			lcd_clear();
			lcd_str("Joc normal");
			selectedMode = 1;
		}
		   
    
    }
	
	char difficulty;
	int difficultySelected = 0;
	if (m == 'o'){
		
		lcd_clear();
		lcd_str("Mod OBSTACOLE.SELECTATI DIFICULATEA:left=HARD   right=EASY");
		while(difficultySelected == 0)
		{	
			check_input();
			if (snake_direction == LEFT)
			{
				difficulty= 'h';
				lcd_clear();
				lcd_str("Joc HARD");
				difficultySelected = 1;
			}
			
			if (snake_direction == RIGHT)
			{
				difficulty = 'e';
				lcd_clear();
				lcd_str("Joc EASY");
				difficultySelected = 1;
			}
		}
		lcd_clear();
 		if(difficulty=='h'){
			
			for(i=0;i<8;i++){
			
				obs[i].x =  (nrows + i * 24) % nrows;
				obs[i].y = (ncols + i * 24) % ncols+ 2;
				lcd_goto_xy(obs[i].x,obs[i].y);
				lcd_str("X");
				dif=8;
				
			}
			
		}
		
		if(difficulty=='e'){
			for(i=0;i<4;i++){
				
				obs[i].x = rand() % nrows + 8;
				obs[i].y = rand() % ncols + 2;
				lcd_goto_xy(obs[i].x,obs[i].y);
				lcd_str("X");
				dif=4;
				lcd_str("Dificultate:EASY.PT A INCEPE, APASATI UNA DIN TASTELE PRECIZATE MAI SUS!");
			}
						
		}
			
		mod =1;
		
	}
	
	if (m == 'n') {
		lcd_str("Mod NORMAL.PT A INCEPE, APASATI UNA DIN TASTELE PRECIZATE MAI SUS!");	
	}
	
	
    
    
    return 0;
}

